def fn call_lib_ok%
rem this calls the compiler either as thing (it is exists) or as file
rem returns 1 if all ok, else 0  or -1 if qlib not found
rem
rem uses global variables: info_message$, error_message$, output_file$
rem comp_options%
rem v. 1.01
local cmdline$,call_error%
  pe_cls#scr_chan%
  pe_print#scr_chan%, cr$&centr$(info_message$(1),warning_width%)&cr$&centr$(sav_file$,warning_width%)
  cmdline$=sav_file$&" -LIST "&errfile$ : rem QLib command line
  if job_name$<>""
     if addversion% and version$<>""
	cmdline$=cmdline$&" -NAME "&job_name$&'_v.'&version$
     else
       cmdline$=cmdline$&" -NAME "&job_name$
     endif     : rem add version if this is wished in linker control file
  endif      : rem now	set the options
  if comp_options%(0):cmdline$=cmdline$&" -NOWINDS"
  if comp_options%(1):cmdline$=cmdline$&" -NOBEEP"
  if comp_options%(2):cmdline$=cmdline$&" -AUTOF"
  if comp_options%(3):cmdline$=cmdline$&" -DEBUG"
  if comp_options%(4):cmdline$=cmdline$&" -NONAMES"
  if comp_options%(5):cmdline$=cmdline$&" -NOLINE"
  if comp_options%(6):cmdline$=cmdline$&" -STAT"
  if comp_options%(7):cmdline$=cmdline$&" -RUN"
  call_error%=0:
   if is_thg(qlib_thg$)
     EXEP_W qlib_thg$ ; cmdline$: rem exec the compiler thing now
  else
    if not ftest(qlib_file$) and qlib_file$<>""
       ew qlib_file$ ; cmdline$ : rem exec qlib file if found
     else
       unst			: rem neither QLIB thing nor file found!
       error_string$=error_message$(4)
       print_error 0		: rem so complain
       return -1
     endif
  endif
  if delete_sav_file%:delete sav_file$
  if check_errors%(errfile$)
    unst
    error_string$=error_message$(5) : rem there were errors during compilation
    print_error 0
    return 0			: rem errors
  endif
  return 1			: rem if we come here, all is ok!
end def call_lib_ok%
:
def proc set_compiler_options
rem this lets the user set the different compiler options
rem uses the global var comp_options%, comp_options$
rem it actually only sets the status in the comp_options% array
local res
  pos_ptr main_defn,200*65536+30,-1
  res=list_select("Comp. Options",comp_options$,comp_options%,4,,,,main_coul%,-1)
end def set_compiler_options
:
